(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-base-foundation'), require('@ionic/angular'), require('@angular/core'), require('@ionic-native/file/ngx')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/file-util', ['exports', 'totvs-log-base-foundation', '@ionic/angular', '@angular/core', '@ionic-native/file/ngx'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['file-util'] = {}),global.totvsLogBaseFoundation,global.angular,global.ng.core,global.ngx));
}(this, (function (exports,totvsLogBaseFoundation,angular,core,ngx) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO - Verificar se é válido ter classes abstratas para os utilitários
    /**
     * Utilitário para auxiliar o desenvolvimento utilizando o plugin de arquivo
     * com métodos que facilitam a manipulação de arquivos no aplicativo
     */
    var FileUtilProvider = /** @class */ (function () {
        /**
         * @ignore
         * Método construtor responsável por inicializar o serviço
         * platform Serviço relacionado a plataforma
         * file Serviço do plugin nativo de arquivo
         * events Serviço de eventos do Ionic
         */
        function FileUtilProvider(platform, file) {
            var _this = this;
            this.file = file;
            /**
             * @ignore
             * Indica se a plataforma é cordova
             */
            this.isCordova = false;
            platform.ready().then(( /**
             * @return {?}
             */function () { return _this.isCordova = platform.is('cordova'); }));
        }
        /**
         * Método responsável por remover um arquivo
         * uri URI do arquivo que deve ser removido
         * Objeto que representa o resultado da remoção do arquivo
         */
        /**
         * Método responsável por remover um arquivo
         * uri URI do arquivo que deve ser removido
         * Objeto que representa o resultado da remoção do arquivo
         * @param {?} uri
         * @return {?}
         */
        FileUtilProvider.prototype.removeFile = /**
         * Método responsável por remover um arquivo
         * uri URI do arquivo que deve ser removido
         * Objeto que representa o resultado da remoção do arquivo
         * @param {?} uri
         * @return {?}
         */
            function (uri) {
                return __awaiter(this, void 0, void 0, function () {
                    var fileName, path, removeResult, error_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (this.isCordova === false) {
                                    throw new totvsLogBaseFoundation.CriticalError('Platform is not cordova (removeFile)');
                                }
                                if (!uri || uri === '') {
                                    throw new totvsLogBaseFoundation.CriticalError('URI invalid (removeFile)');
                                }
                                fileName = this.getFilenameFromUri(uri);
                                path = this.getPathFromUri(uri);
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, this.file.removeFile(path, fileName)];
                            case 2:
                                removeResult = _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                error_1 = _a.sent();
                                throw new totvsLogBaseFoundation.CriticalError('Error in remove file', error_1);
                            case 4: return [2 /*return*/, removeResult];
                        }
                    });
                });
            };
        /**
         * Método responsável por transferir os arquivos para o storage do aplicativo
         * uris URIs dos arquivos que devem ser copiados
         * Lista de URIs dos arquivos copiados para o storage do aplicativo
         */
        /**
         * Método responsável por transferir os arquivos para o storage do aplicativo
         * uris URIs dos arquivos que devem ser copiados
         * Lista de URIs dos arquivos copiados para o storage do aplicativo
         * @param {...?} uris
         * @return {?}
         */
        FileUtilProvider.prototype.fileCacheToAppStorage = /**
         * Método responsável por transferir os arquivos para o storage do aplicativo
         * uris URIs dos arquivos que devem ser copiados
         * Lista de URIs dos arquivos copiados para o storage do aplicativo
         * @param {...?} uris
         * @return {?}
         */
            function () {
                var uris = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    uris[_i] = arguments[_i];
                }
                return __awaiter(this, void 0, void 0, function () {
                    var promisesCopy, filesCopied, error_2, promisesRemove, filesUrl, error_3;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (this.isCordova === false) {
                                    throw new totvsLogBaseFoundation.CriticalError('Platform is not cordova');
                                }
                                promisesCopy = [];
                                uris.forEach(( /**
                                 * @param {?} uri
                                 * @return {?}
                                 */function (uri) {
                                    /** @type {?} */
                                    var fileName = decodeURI(_this.getFilenameFromUri(uri));
                                    /** @type {?} */
                                    var path = _this.getPathFromUri(uri);
                                    promisesCopy.push(_this.file.copyFile(path, fileName, _this.file.dataDirectory, fileName)
                                        .then(( /**
                                 * @param {?} entry
                                 * @return {?}
                                 */function (entry) {
                                        return {
                                            sourcePath: path,
                                            sourceFileName: fileName,
                                            targetFile: entry
                                        };
                                    })));
                                }));
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, Promise.all(promisesCopy)];
                            case 2:
                                filesCopied = _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                error_2 = _a.sent();
                                throw new totvsLogBaseFoundation.CriticalError("Error in copy file", error_2);
                            case 4:
                                promisesRemove = [];
                                filesUrl = [];
                                filesCopied.forEach(( /**
                                 * @param {?} fileCopied
                                 * @return {?}
                                 */function (fileCopied) {
                                    filesUrl.push(fileCopied.targetFile.toURL());
                                    promisesRemove.push(_this.file.removeFile(fileCopied.sourcePath, fileCopied.sourceFileName)
                                        .then(( /**
                                 * @param {?} result
                                 * @return {?}
                                 */function (result) {
                                        return result;
                                    })));
                                }));
                                _a.label = 5;
                            case 5:
                                _a.trys.push([5, 7, , 8]);
                                return [4 /*yield*/, Promise.all(promisesRemove)];
                            case 6:
                                _a.sent();
                                return [3 /*break*/, 8];
                            case 7:
                                error_3 = _a.sent();
                                throw new totvsLogBaseFoundation.CriticalError("Error in remove file", error_3);
                            case 8: return [2 /*return*/, filesUrl];
                        }
                    });
                });
            };
        /**
         * @ignore
         * Método responsável por recuperar o nome do arquivo de um URI
         * uri URI do arquivo
         */
        /**
         * @ignore
         * Método responsável por recuperar o nome do arquivo de um URI
         * uri URI do arquivo
         * @private
         * @param {?} uri
         * @return {?}
         */
        FileUtilProvider.prototype.getFilenameFromUri = /**
         * @ignore
         * Método responsável por recuperar o nome do arquivo de um URI
         * uri URI do arquivo
         * @private
         * @param {?} uri
         * @return {?}
         */
            function (uri) {
                /** @type {?} */
                var fileName;
                try {
                    /** @type {?} */
                    var fileNameArray = uri.split('/');
                    fileName = fileNameArray[fileNameArray.length - 1];
                }
                catch (error) {
                    throw new totvsLogBaseFoundation.CriticalError('Error (getFilenameFromUri)', error);
                }
                return fileName;
            };
        /**
         * @ignore
         * Método responsável por recuperar o path do arquivo de um URI
         * uri URI do arquivo
         */
        /**
         * @ignore
         * Método responsável por recuperar o path do arquivo de um URI
         * uri URI do arquivo
         * @private
         * @param {?} uri
         * @return {?}
         */
        FileUtilProvider.prototype.getPathFromUri = /**
         * @ignore
         * Método responsável por recuperar o path do arquivo de um URI
         * uri URI do arquivo
         * @private
         * @param {?} uri
         * @return {?}
         */
            function (uri) {
                /** @type {?} */
                var filePath;
                try {
                    /** @type {?} */
                    var fileNameArray = uri.split('/');
                    fileNameArray.splice(fileNameArray.length - 1, 1);
                    filePath = fileNameArray.join('/');
                }
                catch (error) {
                    throw new totvsLogBaseFoundation.CriticalError('Error (getPathFromUri)', error);
                }
                return filePath;
            };
        FileUtilProvider.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        FileUtilProvider.ctorParameters = function () {
            return [
                { type: angular.Platform },
                { type: ngx.File }
            ];
        };
        return FileUtilProvider;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que contém um provedor utilitário que auxilia na
     * utilização do plugin nativo de manipulação de arquivo
     */
    var FileUtilModule = /** @class */ (function () {
        function FileUtilModule() {
        }
        FileUtilModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            ngx.File,
                            FileUtilProvider
                        ]
                    },] }
        ];
        return FileUtilModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FileUtilModule = FileUtilModule;
    exports.FileUtilProvider = FileUtilProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-file-util.umd.js.map