(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-mobile-foundation'), require('totvs-log-base-foundation'), require('@ionic/angular'), require('@angular/core'), require('@ionic-native/geolocation/ngx')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/geolocation-util', ['exports', 'totvs-log-mobile-foundation', 'totvs-log-base-foundation', '@ionic/angular', '@angular/core', '@ionic-native/geolocation/ngx'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['geolocation-util'] = {}),global['totvs-log-mobile-foundation'],global.totvsLogBaseFoundation,global.angular,global.ng.core,global.ngx));
}(this, (function (exports,totvsLogMobileFoundation,totvsLogBaseFoundation,angular,core,ngx) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO - Verificar se é válido ter classes abstratas para os utilitários
    /**
     * Utilitário para auxiliar o desenvolvimento utilizando o plugin de geolocalização
     * com métodos que facilitam a solicitação de permissão e identificação de geolocalização
     */
    var GeolocationUtilProvider = /** @class */ (function () {
        /**
         * @ignore
         * Método responsável por construir o serviço
         * platform Serviço relacionado a plataforma
         * geolocation Serviço do plugin nativo de geolocalização
         * global Serviço global da aplicação
         */
        function GeolocationUtilProvider(platform, geolocation, global) {
            var _this = this;
            this.geolocation = geolocation;
            this.global = global;
            /**
             * @ignore
             * Indica se a plataforma é cordova
             */
            this.isCordova = false;
            platform.ready().then(( /**
             * @return {?}
             */function () { return _this.isCordova = platform.is('cordova'); }));
        }
        /**
         * Método responsável por obter a posição corrente do usuário
         * {GeolocationOptions} options Opções para recuperação da geolocalização
         * Posição
         */
        /**
         * Método responsável por obter a posição corrente do usuário
         * {GeolocationOptions} options Opções para recuperação da geolocalização
         * Posição
         * @param {?} options
         * @return {?}
         */
        GeolocationUtilProvider.prototype.getCurrentPosition = /**
         * Método responsável por obter a posição corrente do usuário
         * {GeolocationOptions} options Opções para recuperação da geolocalização
         * Posição
         * @param {?} options
         * @return {?}
         */
            function (options) {
                return __awaiter(this, void 0, void 0, function () {
                    var msg;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (this.isCordova === false) {
                                    msg = new totvsLogBaseFoundation.BaseMessage({
                                        literal: 'recursoNaoEstaDisponivelMsg'
                                    });
                                    this.global.msg.showMessage(msg);
                                    throw new totvsLogBaseFoundation.CriticalError('Platform is not cordova');
                                }
                                return [4 /*yield*/, this.geolocation.getCurrentPosition(options)];
                            case 1: return [2 /*return*/, _a.sent()];
                        }
                    });
                });
            };
        /**
         * Método responsável por calcular a distância entre dois pontos através de suas latitudes e longitudes
         * point1 Coordenadas do primeiro ponto
         * point2 Coordenadas do segundo ponto
         */
        /**
         * Método responsável por calcular a distância entre dois pontos através de suas latitudes e longitudes
         * point1 Coordenadas do primeiro ponto
         * point2 Coordenadas do segundo ponto
         * @param {?} point1
         * @param {?} point2
         * @return {?}
         */
        GeolocationUtilProvider.prototype.calculatePointsKMDistance = /**
         * Método responsável por calcular a distância entre dois pontos através de suas latitudes e longitudes
         * point1 Coordenadas do primeiro ponto
         * point2 Coordenadas do segundo ponto
         * @param {?} point1
         * @param {?} point2
         * @return {?}
         */
            function (point1, point2) {
                if (!this.validGeoPositionPoint(point1) || !this.validGeoPositionPoint(point2)) {
                    throw new Error('ERROR - Invalid values');
                }
                if (point1.latitude === point2.latitude && point1.longitude === point2.longitude) {
                    return 0;
                }
                /** @type {?} */
                var radlat1 = this.degreesToRad(point1.latitude);
                /** @type {?} */
                var radlat2 = this.degreesToRad(point2.latitude);
                /** @type {?} */
                var theta = point1.longitude - point2.longitude;
                /** @type {?} */
                var radtheta = this.degreesToRad(theta);
                /** @type {?} */
                var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
                if (dist > 1) {
                    dist = 1;
                }
                dist = Math.acos(dist);
                dist = dist * 180 / Math.PI;
                dist = dist * 60 * 1.1515;
                // KM
                return dist * 1.609344;
            };
        /**
         * Converte os graus decimais em radianos
         * degrees Graus decimais
         */
        /**
         * Converte os graus decimais em radianos
         * degrees Graus decimais
         * @param {?} degrees
         * @return {?}
         */
        GeolocationUtilProvider.prototype.degreesToRad = /**
         * Converte os graus decimais em radianos
         * degrees Graus decimais
         * @param {?} degrees
         * @return {?}
         */
            function (degrees) {
                return Math.PI * degrees / 180;
            };
        /**
         * Valida os valores do ponto recebido e retorna o resultado
         * point Ponto contendo latitude e longitude
         */
        /**
         * Valida os valores do ponto recebido e retorna o resultado
         * point Ponto contendo latitude e longitude
         * @param {?} point
         * @return {?}
         */
        GeolocationUtilProvider.prototype.validGeoPositionPoint = /**
         * Valida os valores do ponto recebido e retorna o resultado
         * point Ponto contendo latitude e longitude
         * @param {?} point
         * @return {?}
         */
            function (point) {
                if (!point) {
                    return false;
                }
                if (isNaN(point.latitude) || isNaN(point.longitude)) {
                    return false;
                }
                if (point.latitude === null || point.longitude === null) {
                    return false;
                }
                if (point.latitude > 90 || point.latitude < -90) {
                    return false;
                }
                if (point.longitude > 180 || point.longitude < -180) {
                    return false;
                }
                return true;
            };
        GeolocationUtilProvider.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        GeolocationUtilProvider.ctorParameters = function () {
            return [
                { type: angular.Platform },
                { type: ngx.Geolocation },
                { type: totvsLogMobileFoundation.GlobalService }
            ];
        };
        return GeolocationUtilProvider;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Módulo que contém um provedor utilitário que auxilia na
     * utilização do plugin nativo de geolocalização
     */
    var GeolocationUtilModule = /** @class */ (function () {
        function GeolocationUtilModule() {
        }
        GeolocationUtilModule.decorators = [
            { type: core.NgModule, args: [{
                        providers: [
                            ngx.Geolocation,
                            GeolocationUtilProvider
                        ]
                    },] }
        ];
        return GeolocationUtilModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.GeolocationUtilModule = GeolocationUtilModule;
    exports.GeolocationUtilProvider = GeolocationUtilProvider;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-geolocation-util.umd.js.map