(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/oidc-cordova', ['exports', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['oidc-cordova'] = {}),global.rxjs,global.rxjs.operators));
}(this, (function (exports,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var OidcCordovaIabEvents = /** @class */ (function () {
        function OidcCordovaIabEvents() {
        }
        OidcCordovaIabEvents.LoadSuccessful = 'OidcCordovaIabEventsLoadSuccessful';
        OidcCordovaIabEvents.LoadFailed = 'OidcCordovaIabEventsLoadFailed';
        return OidcCordovaIabEvents;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe responsável pelo Popup utilizado no processo
     * de autenticação com Oidc no Ionic
     */
    var OidcCordovaPopupWindow = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe
         * iab Serviço do plugin nativo ionic InAppBrowser
         * popupParams Parâmetros para o popup
         */
        function OidcCordovaPopupWindow(iab, popupParams) {
            this.iab = iab;
            this.popupParams = popupParams;
            this.navigated = new rxjs.Subject();
            this.redirectUri = this.popupParams.startUrl;
        }
        Object.defineProperty(OidcCordovaPopupWindow.prototype, "promise", {
            /** Método acessor do promise retornado pelo método Navigate */
            get: /**
             * Método acessor do promise retornado pelo método Navigate
             * @return {?}
             */ function () {
                return this.internalPromise;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Método responsável por realizar a navegação
         * navParams Parâmetros de navegação
         */
        /**
         * Método responsável por realizar a navegação
         * navParams Parâmetros de navegação
         * @param {?} navParams
         * @return {?}
         */
        OidcCordovaPopupWindow.prototype.navigate = /**
         * Método responsável por realizar a navegação
         * navParams Parâmetros de navegação
         * @param {?} navParams
         * @return {?}
         */
            function (navParams) {
                var _this = this;
                this.internalPromise = new Promise(( /**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */function (resolve, reject) {
                    _this.internalReject = reject;
                    /** @type {?} */
                    var errorMsg = '';
                    if (!navParams || !navParams.url) {
                        errorMsg = 'No url provided';
                    }
                    else {
                        /** @type {?} */
                        var features = _this.popupParams.popupWindowFeatures || OidcCordovaPopupWindow.DefaultPopupFeatures;
                        /** @type {?} */
                        var target = _this.popupParams.popupWindowTarget || OidcCordovaPopupWindow.DefaultPopupTarget;
                        _this.popup = _this.iab.create(navParams.url, target, features);
                        if (_this.popup) {
                            // Evento 'exit'
                            _this.popupExitSub = _this.popup.on('exit').subscribe(( /**
                             * @param {?} event
                             * @return {?}
                             */function (event) {
                                _this.closePopup();
                                reject(new Error(event.message));
                            }));
                            // Evento 'loadstart'
                            _this.popupLoadStartSub = _this.popup.on('loadstart').subscribe(( /**
                             * @param {?} event
                             * @return {?}
                             */function (event) {
                                /** @type {?} */
                                var url = event.url;
                                if (url.indexOf(_this.redirectUri) === 0) {
                                    _this.closePopup();
                                    resolve({ url: url });
                                }
                                else if (url.indexOf('error') !== -1) {
                                    _this.closePopup();
                                    reject(new Error("Load start error. URL: " + url));
                                }
                            }));
                        }
                        else {
                            errorMsg = 'Error opening popup window';
                        }
                    }
                    if (errorMsg !== '') {
                        _this.closePopup();
                        reject(new Error('Error opening popup window'));
                    }
                }));
                this.navigated.next(this.promise);
                return this.promise;
            };
        /**
         * Método responsável por fechar
         */
        /**
         * Método responsável por fechar
         * @return {?}
         */
        OidcCordovaPopupWindow.prototype.close = /**
         * Método responsável por fechar
         * @return {?}
         */
            function () {
                this.closePopup();
                this.internalReject();
            };
        /**
         * Método responsável por fechar o popup
         */
        /**
         * Método responsável por fechar o popup
         * @private
         * @return {?}
         */
        OidcCordovaPopupWindow.prototype.closePopup = /**
         * Método responsável por fechar o popup
         * @private
         * @return {?}
         */
            function () {
                if (this.popup) {
                    this.popupExitSub.unsubscribe();
                    this.popupLoadStartSub.unsubscribe();
                    this.popup.close();
                    this.popup = undefined;
                }
            };
        /**
         * Propriedades padrão do Popup
         */
        OidcCordovaPopupWindow.DefaultPopupFeatures = 'location=no,toolbar=no,zoom=no';
        /**
         * Destino padrão do Popup
         */
        OidcCordovaPopupWindow.DefaultPopupTarget = '_blank';
        return OidcCordovaPopupWindow;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe responsável pela navegação com popup utilizado no processo
     * de autenticação com Oidc no Ionic
     */
    var /**
     * Classe responsável pela navegação com popup utilizado no processo
     * de autenticação com Oidc no Ionic
     */ OidcCordovaPopupNavigator = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe
         * iab Serviço do plugin nativo InAppBrowser
         */
        function OidcCordovaPopupNavigator(iab, events) {
            this.iab = iab;
            this.events = events;
        }
        /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         */
        /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         * @param {?} params
         * @return {?}
         */
        OidcCordovaPopupNavigator.prototype.prepare = /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         * @param {?} params
         * @return {?}
         */
            function (params) {
                var _this = this;
                /** @type {?} */
                var popup = new OidcCordovaPopupWindow(this.iab, params);
                popup.navigated.pipe(operators.take(1)).subscribe(( /**
                 * @param {?} promise
                 * @return {?}
                 */function (promise) {
                    promise
                        .then(( /**
                 * @param {?} value
                 * @return {?}
                 */function (value) {
                        _this.events.publish(OidcCordovaIabEvents.LoadSuccessful);
                        return value;
                    }))
                        .catch(( /**
                 * @param {?} err
                 * @return {?}
                 */function (err) {
                        _this.events.publish(OidcCordovaIabEvents.LoadFailed);
                        throw err;
                    }));
                }));
                return Promise.resolve(popup);
            };
        return OidcCordovaPopupNavigator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Classe responsável pelo Iframe utilizado no processo
     * de autenticação com Oidc no Ionic
     */
    var /**
     * Classe responsável pelo Iframe utilizado no processo
     * de autenticação com Oidc no Ionic
     */ OidcCordovaIFrameNavigator = /** @class */ (function () {
        /**
         * Método construtor que inicializa a classe
         * iab Serviço do plugin nativo InAppBrowser
         */
        function OidcCordovaIFrameNavigator(iab) {
            this.iab = iab;
        }
        /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         */
        /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         * @param {?} params
         * @return {?}
         */
        OidcCordovaIFrameNavigator.prototype.prepare = /**
         * Método que prepara a janela de popup
         * params Parâmetros para a janela de popup
         * @param {?} params
         * @return {?}
         */
            function (params) {
                params.popupWindowFeatures = 'hidden=yes';
                params.isIframe = true;
                /** @type {?} */
                var popup = new OidcCordovaPopupWindow(this.iab, params);
                return Promise.resolve(popup);
            };
        return OidcCordovaIFrameNavigator;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.OidcCordovaIabEvents = OidcCordovaIabEvents;
    exports.OidcCordovaPopupWindow = OidcCordovaPopupWindow;
    exports.OidcCordovaPopupNavigator = OidcCordovaPopupNavigator;
    exports.OidcCordovaIFrameNavigator = OidcCordovaIFrameNavigator;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-oidc-cordova.umd.js.map