(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('totvs-log-base-foundation')) :
    typeof define === 'function' && define.amd ? define('totvs-log-mobile-foundation/src/sync-sqlite-util', ['exports', 'totvs-log-base-foundation'], factory) :
    (factory((global['totvs-log-mobile-foundation'] = global['totvs-log-mobile-foundation'] || {}, global['totvs-log-mobile-foundation'].src = global['totvs-log-mobile-foundation'].src || {}, global['totvs-log-mobile-foundation'].src['sync-sqlite-util'] = {}),global.totvsLogBaseFoundation));
}(this, (function (exports,totvsLogBaseFoundation) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Utilitário com funções para sincronização de dados em banco sqlite
     */
    var /**
     * Utilitário com funções para sincronização de dados em banco sqlite
     */ SyncSqLiteUtil = /** @class */ (function () {
        /**
         * Creates an instance of SyncDbUtils.
         * cn a conexão que será utilizada para salvar os dados
         */
        function SyncSqLiteUtil(cn) {
            this.cn = cn;
        }
        /**
         * Cria um relacionamento 1-n, inserindo na entidade filha o id do pai
         *
         * @template T
         * items os registros pai
         * fatherTable o nome da tabela pi
         * @returns Os registros relacionados
         */
        /**
         * Cria um relacionamento 1-n, inserindo na entidade filha o id do pai
         *
         * items os registros pai
         * fatherTable o nome da tabela pi
         * @template T
         * @param {?} items
         * @param {?} fatherTable
         * @return {?} Os registros relacionados
         */
        SyncSqLiteUtil.prototype.updateChildrenRelation = /**
         * Cria um relacionamento 1-n, inserindo na entidade filha o id do pai
         *
         * items os registros pai
         * fatherTable o nome da tabela pi
         * @template T
         * @param {?} items
         * @param {?} fatherTable
         * @return {?} Os registros relacionados
         */
            function (items, fatherTable) {
                var e_1, _a, e_2, _b;
                // FIXME: Fazer com que todos os filhos também tenha relacionamento com o pai mestre
                /** @type {?} */
                var childrenFound = [];
                /** @type {?} */
                var models = Object.keys(items[0]);
                try {
                    for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
                        var item = items_1_1.value;
                        var _loop_1 = function (model) {
                            var e_3, _a;
                            if (totvsLogBaseFoundation.UtilsFn.isArray(item[model])) {
                                /** @type {?} */
                                var children = ( /** @type {?} */(item[model]));
                                /** @type {?} */
                                var cf = childrenFound.find(( /**
                                 * @param {?} x
                                 * @return {?}
                                 */function (x) { return x.table === model; }));
                                if (!cf) {
                                    childrenFound.push({ table: model, items: children });
                                }
                                else {
                                    cf.items = cf.items.concat(children);
                                }
                                try {
                                    for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                                        var child = children_1_1.value;
                                        child[fatherTable + "Id"] = item.id;
                                    }
                                }
                                catch (e_3_1) {
                                    e_3 = { error: e_3_1 };
                                }
                                finally {
                                    try {
                                        if (children_1_1 && !children_1_1.done && (_a = children_1.return))
                                            _a.call(children_1);
                                    }
                                    finally {
                                        if (e_3)
                                            throw e_3.error;
                                    }
                                }
                            }
                        };
                        try {
                            for (var models_1 = __values(models), models_1_1 = models_1.next(); !models_1_1.done; models_1_1 = models_1.next()) {
                                var model = models_1_1.value;
                                _loop_1(model);
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (models_1_1 && !models_1_1.done && (_b = models_1.return))
                                    _b.call(models_1);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (items_1_1 && !items_1_1.done && (_a = items_1.return))
                            _a.call(items_1);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                return childrenFound;
            };
        /**
         * Armazena os dados enviados, substituindo o registro anterior e criando tabelas para
         * entidades filhas(arrays)
         * data A requisição de sync com os dados
         * mainTable O nome da tabela principal
         * deleteBefore se deve sempre deletar antes de inserir o registro
         * currentTx a transação corrente, não deve ser passado sem entender o mecanismo interno
         */
        /**
         * Armazena os dados enviados, substituindo o registro anterior e criando tabelas para
         * entidades filhas(arrays)
         * data A requisição de sync com os dados
         * mainTable O nome da tabela principal
         * deleteBefore se deve sempre deletar antes de inserir o registro
         * currentTx a transação corrente, não deve ser passado sem entender o mecanismo interno
         * @template T
         * @param {?} data
         * @param {?} mainTable
         * @param {?=} deleteBefore
         * @param {?=} currentTx
         * @return {?}
         */
        SyncSqLiteUtil.prototype.storeData = /**
         * Armazena os dados enviados, substituindo o registro anterior e criando tabelas para
         * entidades filhas(arrays)
         * data A requisição de sync com os dados
         * mainTable O nome da tabela principal
         * deleteBefore se deve sempre deletar antes de inserir o registro
         * currentTx a transação corrente, não deve ser passado sem entender o mecanismo interno
         * @template T
         * @param {?} data
         * @param {?} mainTable
         * @param {?=} deleteBefore
         * @param {?=} currentTx
         * @return {?}
         */
            function (data, mainTable, deleteBefore, currentTx) {
                if (deleteBefore === void 0) {
                    deleteBefore = true;
                }
                return __awaiter(this, void 0, void 0, function () {
                    var children, model, error_1;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!data.items || data.items.length === 0) {
                                    return [2 /*return*/];
                                }
                                children = this.updateChildrenRelation(data.items, mainTable);
                                model = this.modelWithoutArrays(data.items[0]);
                                if (!!currentTx)
                                    return [3 /*break*/, 5];
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, this.cn.transaction(( /**
                                         * @param {?} tx
                                         * @return {?}
                                         */function (tx) {
                                        _this.checkTableStateTx(tx, mainTable, model, ( /**
                                         * @param {?} txa
                                         * @param {?} rs
                                         * @return {?}
                                         */function (txa, rs) {
                                            var e_4, _a, e_5, _b;
                                            try {
                                                for (var _c = __values(data.items), _d = _c.next(); !_d.done; _d = _c.next()) {
                                                    var item = _d.value;
                                                    _this.upsert(txa, mainTable, model, item, deleteBefore);
                                                }
                                            }
                                            catch (e_4_1) {
                                                e_4 = { error: e_4_1 };
                                            }
                                            finally {
                                                try {
                                                    if (_d && !_d.done && (_a = _c.return))
                                                        _a.call(_c);
                                                }
                                                finally {
                                                    if (e_4)
                                                        throw e_4.error;
                                                }
                                            }
                                            try {
                                                for (var children_2 = __values(children), children_2_1 = children_2.next(); !children_2_1.done; children_2_1 = children_2.next()) {
                                                    var child = children_2_1.value;
                                                    _this.storeData({
                                                        items: child.items
                                                    }, mainTable + "_" + child.table, deleteBefore, tx);
                                                }
                                            }
                                            catch (e_5_1) {
                                                e_5 = { error: e_5_1 };
                                            }
                                            finally {
                                                try {
                                                    if (children_2_1 && !children_2_1.done && (_b = children_2.return))
                                                        _b.call(children_2);
                                                }
                                                finally {
                                                    if (e_5)
                                                        throw e_5.error;
                                                }
                                            }
                                        }));
                                    }))];
                            case 2:
                                _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                error_1 = _a.sent();
                                console.log(error_1);
                                return [3 /*break*/, 4];
                            case 4: return [3 /*break*/, 6];
                            case 5:
                                this.checkTableStateTx(currentTx, mainTable, model, ( /**
                                 * @param {?} tx
                                 * @param {?} rs
                                 * @return {?}
                                 */function (tx, rs) {
                                    var e_6, _a, e_7, _b;
                                    if (mainTable.search('_') !== -1 && data.items.length > 0) {
                                        // Delete childs first
                                        /** @type {?} */
                                        var tables = mainTable.split('_');
                                        tables.splice(tables.length - 1, 1);
                                        /** @type {?} */
                                        var fieldId_1 = tables.join('_') + 'Id';
                                        /** @type {?} */
                                        var fathersId_1 = [];
                                        data.items.forEach(( /**
                                         * @param {?} e
                                         * @return {?}
                                         */function (e) {
                                            if (!fathersId_1.find(( /**
                                             * @param {?} x
                                             * @return {?}
                                             */function (x) { return x === e[fieldId_1]; }))) {
                                                fathersId_1.push(e[fieldId_1]);
                                            }
                                        }));
                                        fathersId_1.forEach(( /**
                                         * @param {?} e
                                         * @return {?}
                                         */function (e) {
                                            console.log("DELETE FROM " + mainTable + " where " + fieldId_1 + " = ?", [e]);
                                            tx.executeSql("DELETE FROM " + mainTable + " where " + fieldId_1 + " = ?", [e], ( /**
                                             * @param {?} txa
                                             * @param {?} res
                                             * @return {?}
                                             */function (txa, res) { }), ( /**
                                             * @param {?} error
                                             * @return {?}
                                             */function (error) { return console.log(error); }));
                                        }));
                                    }
                                    try {
                                        for (var _c = __values(data.items), _d = _c.next(); !_d.done; _d = _c.next()) {
                                            var item = _d.value;
                                            _this.upsert(currentTx, mainTable, model, item, deleteBefore);
                                        }
                                    }
                                    catch (e_6_1) {
                                        e_6 = { error: e_6_1 };
                                    }
                                    finally {
                                        try {
                                            if (_d && !_d.done && (_a = _c.return))
                                                _a.call(_c);
                                        }
                                        finally {
                                            if (e_6)
                                                throw e_6.error;
                                        }
                                    }
                                    try {
                                        for (var children_3 = __values(children), children_3_1 = children_3.next(); !children_3_1.done; children_3_1 = children_3.next()) {
                                            var child = children_3_1.value;
                                            _this.storeData({
                                                items: child.items
                                            }, mainTable + "_" + child.table, deleteBefore, currentTx);
                                        }
                                    }
                                    catch (e_7_1) {
                                        e_7 = { error: e_7_1 };
                                    }
                                    finally {
                                        try {
                                            if (children_3_1 && !children_3_1.done && (_b = children_3.return))
                                                _b.call(children_3);
                                        }
                                        finally {
                                            if (e_7)
                                                throw e_7.error;
                                        }
                                    }
                                }));
                                _a.label = 6;
                            case 6: return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * Retorna se a tabela existe
         * table o nome da tabela que se deseja verificar se existe
         */
        /**
         * Retorna se a tabela existe
         * table o nome da tabela que se deseja verificar se existe
         * @param {?} table
         * @return {?}
         */
        SyncSqLiteUtil.prototype.tableExists = /**
         * Retorna se a tabela existe
         * table o nome da tabela que se deseja verificar se existe
         * @param {?} table
         * @return {?}
         */
            function (table) {
                return __awaiter(this, void 0, void 0, function () {
                    var rs, error_2;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, this.cn.executeSql('SELECT name FROM sqlite_master WHERE type=? AND name=?', ['table', table])];
                            case 1:
                                rs = _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                error_2 = _a.sent();
                                console.log(JSON.stringify(error_2, null, 2));
                                return [3 /*break*/, 3];
                            case 3:
                                if (rs && rs.rows.length > 0 && rs.rows.item(0).name === table) {
                                    return [2 /*return*/, true];
                                }
                                return [2 /*return*/, false];
                        }
                    });
                });
            };
        /**
         * Cria a tabela desejada, se ela não existir
         * table o nome da tabela
         * fields os campos pertencentes a tabela
         */
        /**
         * Cria a tabela desejada, se ela não existir
         * table o nome da tabela
         * fields os campos pertencentes a tabela
         * @param {?} table
         * @param {...?} fields
         * @return {?}
         */
        SyncSqLiteUtil.prototype.createTable = /**
         * Cria a tabela desejada, se ela não existir
         * table o nome da tabela
         * fields os campos pertencentes a tabela
         * @param {?} table
         * @param {...?} fields
         * @return {?}
         */
            function (table) {
                var fields = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    fields[_i - 1] = arguments[_i];
                }
                return __awaiter(this, void 0, void 0, function () {
                    var rs_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, this.cn.executeSql('CREATE TABLE IF NOT EXISTS ' + table + ' (' + fields.join(',') + ')')];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 3];
                            case 2:
                                rs_1 = _a.sent();
                                console.log('success', rs_1);
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * Verifica se os campos já existem na tabela e os adiciona
         * table O nome da tabela
         * fields os campos que serão adicionados, se ainda não existirem na tabela
         */
        /**
         * Verifica se os campos já existem na tabela e os adiciona
         * table O nome da tabela
         * fields os campos que serão adicionados, se ainda não existirem na tabela
         * @param {?} table
         * @param {...?} fields
         * @return {?}
         */
        SyncSqLiteUtil.prototype.checkAndAddFields = /**
         * Verifica se os campos já existem na tabela e os adiciona
         * table O nome da tabela
         * fields os campos que serão adicionados, se ainda não existirem na tabela
         * @param {?} table
         * @param {...?} fields
         * @return {?}
         */
            function (table) {
                var fields = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    fields[_i - 1] = arguments[_i];
                }
                return __awaiter(this, void 0, void 0, function () {
                    var e_8, _a, rs_2, fields_1, fields_1_1, field, hasField, rs_3, e_8_1;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _b.trys.push([0, 2, , 13]);
                                return [4 /*yield*/, this.cn.executeSql('PRAGMA table_info(' + table + ')')];
                            case 1:
                                _b.sent();
                                return [3 /*break*/, 13];
                            case 2:
                                rs_2 = _b.sent();
                                _b.label = 3;
                            case 3:
                                _b.trys.push([3, 10, 11, 12]);
                                fields_1 = __values(fields), fields_1_1 = fields_1.next();
                                _b.label = 4;
                            case 4:
                                if (!!fields_1_1.done)
                                    return [3 /*break*/, 9];
                                field = fields_1_1.value;
                                hasField = this.checkField(rs_2, field);
                                if (!(hasField === false))
                                    return [3 /*break*/, 8];
                                _b.label = 5;
                            case 5:
                                _b.trys.push([5, 7, , 8]);
                                return [4 /*yield*/, this.cn.executeSql("ALTER TABLE " + table + " ADD " + field)];
                            case 6:
                                _b.sent();
                                return [3 /*break*/, 8];
                            case 7:
                                rs_3 = _b.sent();
                                console.log('success', rs_3);
                                return [3 /*break*/, 8];
                            case 8:
                                fields_1_1 = fields_1.next();
                                return [3 /*break*/, 4];
                            case 9: return [3 /*break*/, 12];
                            case 10:
                                e_8_1 = _b.sent();
                                e_8 = { error: e_8_1 };
                                return [3 /*break*/, 12];
                            case 11:
                                try {
                                    if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return))
                                        _a.call(fields_1);
                                }
                                finally {
                                    if (e_8)
                                        throw e_8.error;
                                }
                                return [7 /*endfinally*/];
                            case 12: return [3 /*break*/, 13];
                            case 13: return [2 /*return*/];
                        }
                    });
                });
            };
        /**
         * Retorna um array com os nomes dos campos da entidade, removendo os que são do tipo array
         * obj o objeto que se deseja avaliar
         */
        /**
         * Retorna um array com os nomes dos campos da entidade, removendo os que são do tipo array
         * obj o objeto que se deseja avaliar
         * @private
         * @param {?} obj
         * @return {?}
         */
        SyncSqLiteUtil.prototype.modelWithoutArrays = /**
         * Retorna um array com os nomes dos campos da entidade, removendo os que são do tipo array
         * obj o objeto que se deseja avaliar
         * @private
         * @param {?} obj
         * @return {?}
         */
            function (obj) {
                /** @type {?} */
                var model = Object.keys(obj);
                for (var i = model.length - 1; i > -1; i--) {
                    /** @type {?} */
                    var field = model[i];
                    if (totvsLogBaseFoundation.UtilsFn.isArray(obj[field])) {
                        model.splice(i, 1);
                    }
                }
                return model;
            };
        /**
         * Executa o sql necessário para realizar o upsert de um registro, dentro de uma transação
         * tx a transação corrente
         * table o nome da tabela
         * model os campos envolvidos
         * item o item que se deseja inserir
         * deleteBefore se deve sempre excluir o registro antes de inserir
         */
        /**
         * Executa o sql necessário para realizar o upsert de um registro, dentro de uma transação
         * tx a transação corrente
         * table o nome da tabela
         * model os campos envolvidos
         * item o item que se deseja inserir
         * deleteBefore se deve sempre excluir o registro antes de inserir
         * @private
         * @param {?} tx
         * @param {?} table
         * @param {?} model
         * @param {?} item
         * @param {?} deleteBefore
         * @return {?}
         */
        SyncSqLiteUtil.prototype.upsert = /**
         * Executa o sql necessário para realizar o upsert de um registro, dentro de uma transação
         * tx a transação corrente
         * table o nome da tabela
         * model os campos envolvidos
         * item o item que se deseja inserir
         * deleteBefore se deve sempre excluir o registro antes de inserir
         * @private
         * @param {?} tx
         * @param {?} table
         * @param {?} model
         * @param {?} item
         * @param {?} deleteBefore
         * @return {?}
         */
            function (tx, table, model, item, deleteBefore) {
                if (deleteBefore) {
                    if (table.search('_') === -1) { // Pula deleção de tabelas-filha
                        console.log("DELETE FROM " + table + " where id = ?", [item.id]);
                        tx.executeSql("DELETE FROM " + table + " where id = ?", [item.id], ( /**
                         * @param {?} txa
                         * @param {?} rsa
                         * @return {?}
                         */function (txa, rsa) { }), ( /**
                         * @param {?} error
                         * @return {?}
                         */function (error) { return console.log(error); }));
                    }
                }
                console.log("INSERT INTO " + table + " (" + model.join(',') + ") VALUES(" + totvsLogBaseFoundation.SqlUtilsFn.objectToSqlstring(item, model) + ")");
                // tslint:disable-next-line:max-line-length
                tx.executeSql("INSERT INTO " + table + " (" + model.join(',') + ") VALUES(" + totvsLogBaseFoundation.SqlUtilsFn.objectToSqlstring(item, model) + ")", undefined, ( /**
                 * @param {?} txa
                 * @param {?} rsa
                 * @return {?}
                 */function (txa, rsa) { }), ( /**
                 * @param {?} error
                 * @return {?}
                 */function (error) { return console.log(error); }));
            };
        /**
         * Na consulta de campos, verifica se o campo está presente na tabela
         * rs o recordset com os registros
         * field o nome do campo desejado
         */
        /**
         * Na consulta de campos, verifica se o campo está presente na tabela
         * rs o recordset com os registros
         * field o nome do campo desejado
         * @private
         * @param {?} rs
         * @param {?} field
         * @return {?}
         */
        SyncSqLiteUtil.prototype.checkField = /**
         * Na consulta de campos, verifica se o campo está presente na tabela
         * rs o recordset com os registros
         * field o nome do campo desejado
         * @private
         * @param {?} rs
         * @param {?} field
         * @return {?}
         */
            function (rs, field) {
                /** @type {?} */
                var hasField = false;
                for (var i = 0; i < rs.rows.length; i++) {
                    if (rs.rows.item(i).name === field) {
                        hasField = true;
                        break;
                    }
                }
                return hasField;
            };
        /**
         * Cria ou atualização a estrutura da tabela dentro de uma transação
         * tx a transação corrente
         * mainTable o nome da tabela
         * model os campos da tabela
         * afterTx o que fazer após a transação ocorrer com sucesso
         */
        /**
         * Cria ou atualização a estrutura da tabela dentro de uma transação
         * tx a transação corrente
         * mainTable o nome da tabela
         * model os campos da tabela
         * afterTx o que fazer após a transação ocorrer com sucesso
         * @private
         * @param {?} tx
         * @param {?} mainTable
         * @param {?} model
         * @param {?} afterTx
         * @return {?}
         */
        SyncSqLiteUtil.prototype.checkTableStateTx = /**
         * Cria ou atualização a estrutura da tabela dentro de uma transação
         * tx a transação corrente
         * mainTable o nome da tabela
         * model os campos da tabela
         * afterTx o que fazer após a transação ocorrer com sucesso
         * @private
         * @param {?} tx
         * @param {?} mainTable
         * @param {?} model
         * @param {?} afterTx
         * @return {?}
         */
            function (tx, mainTable, model, afterTx) {
                var _this = this;
                tx.executeSql('SELECT name FROM sqlite_master WHERE type=? AND name=?', ['table', mainTable], ( /**
                 * @param {?} txa
                 * @param {?} rsa
                 * @return {?}
                 */function (txa, rsa) {
                    if (rsa && rsa.rows.length > 0 && rsa.rows.item(0).name === mainTable) {
                        txa.executeSql('PRAGMA table_info(' + mainTable + ')', undefined, ( /**
                         * @param {?} txb
                         * @param {?} rsb
                         * @return {?}
                         */function (txb, rsb) {
                            var e_9, _a, e_10, _b;
                            /** @type {?} */
                            var qtd = 0;
                            /** @type {?} */
                            var fieldsToAdd = [];
                            try {
                                for (var model_1 = __values(model), model_1_1 = model_1.next(); !model_1_1.done; model_1_1 = model_1.next()) {
                                    var field = model_1_1.value;
                                    /** @type {?} */
                                    var hasField = _this.checkField(rsb, field);
                                    if (hasField === false) {
                                        qtd++;
                                        fieldsToAdd.push(field);
                                    }
                                }
                            }
                            catch (e_9_1) {
                                e_9 = { error: e_9_1 };
                            }
                            finally {
                                try {
                                    if (model_1_1 && !model_1_1.done && (_a = model_1.return))
                                        _a.call(model_1);
                                }
                                finally {
                                    if (e_9)
                                        throw e_9.error;
                                }
                            }
                            if (fieldsToAdd.length === 0) {
                                afterTx(txb, rsb);
                            }
                            try {
                                for (var fieldsToAdd_1 = __values(fieldsToAdd), fieldsToAdd_1_1 = fieldsToAdd_1.next(); !fieldsToAdd_1_1.done; fieldsToAdd_1_1 = fieldsToAdd_1.next()) {
                                    var field = fieldsToAdd_1_1.value;
                                    txb.executeSql("ALTER TABLE " + mainTable + " ADD " + field, undefined, ( /**
                                     * @param {?} txc
                                     * @param {?} rsc
                                     * @return {?}
                                     */function (txc, rsc) {
                                        qtd--;
                                        if (qtd === 0) {
                                            afterTx(txc, rsc);
                                        }
                                    }));
                                }
                            }
                            catch (e_10_1) {
                                e_10 = { error: e_10_1 };
                            }
                            finally {
                                try {
                                    if (fieldsToAdd_1_1 && !fieldsToAdd_1_1.done && (_b = fieldsToAdd_1.return))
                                        _b.call(fieldsToAdd_1);
                                }
                                finally {
                                    if (e_10)
                                        throw e_10.error;
                                }
                            }
                        }));
                    }
                    else {
                        txa.executeSql('CREATE TABLE IF NOT EXISTS ' + mainTable + ' (' + model.join(',') + ')', undefined, ( /**
                         * @param {?} txb
                         * @param {?} rsb
                         * @return {?}
                         */function (txb, rsb) {
                            afterTx(txb, rsb);
                        }));
                    }
                }));
            };
        return SyncSqLiteUtil;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.SyncSqLiteUtil = SyncSqLiteUtil;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=totvs-log-mobile-foundation-src-sync-sqlite-util.umd.js.map