import { NgModule } from '@angular/core';
import { Platform, NavParams } from '@ionic/angular';
import { StatusBar } from '@ionic-native/status-bar/ngx';
import { SplashScreen } from '@ionic-native/splash-screen/ngx';
import { defer } from 'rxjs';
import { __awaiter } from 'tslib';
import { UtilsFn } from 'totvs-log-base-foundation';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe Platform e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Platform, useClass: PlatformMock},
 *   ...
 * ]
 * ```
 */
class PlatformMock {
    /**
     * Método que simula a ação de preparado da plataforma
     * @return {?}
     */
    ready() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => {
            resolve('READY');
        }));
    }
    /**
     * Método que simula o retorno dos parâmetros de query de URL
     * @return {?}
     */
    getQueryParam() {
        return true;
    }
    /**
     * Método que simula o registro da ação para o botão 'Voltar'
     * fn
     * priority
     * @param {?} fn
     * @param {?=} priority
     * @return {?}
     */
    registerBackButtonAction(fn, priority) {
        return ((/**
         * @return {?}
         */
        () => true));
    }
    /**
     * Método que simula a verificação de foco
     * ele
     * @param {?} ele
     * @return {?}
     */
    hasFocus(ele) {
        return true;
    }
    /**
     * Método que simula o retorno do 'document'
     * @return {?}
     */
    doc() {
        return document;
    }
    /**
     * Método que simula o retorno do 'is'
     * @return {?}
     */
    is() {
        return true;
    }
    /**
     * Método que simula o retorno do estilo de um elemento
     * container
     * @param {?} container
     * @return {?}
     */
    getElementComputedStyle(container) {
        return {
            paddingLeft: '10',
            paddingTop: '10',
            paddingRight: '10',
            paddingBottom: '10',
        };
    }
    /**
     * Método que simula o evento de redimensionamento de tela
     * callback
     * @param {?} callback
     * @return {?}
     */
    onResize(callback) {
        return callback;
    }
    /**
     * Método que simula o registro de evento de escuta
     * ele
     * eventName
     * callback
     * @param {?} ele
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    registerListener(ele, eventName, callback) {
        return ((/**
         * @return {?}
         */
        () => true));
    }
    /**
     * Método que simula o retorno do método 'win'
     * @return {?}
     */
    win() {
        return window;
    }
    /**
     * Método que simula o retorno do método 'raf'
     * callback
     * @param {?} callback
     * @return {?}
     */
    raf(callback) {
        return 1;
    }
    /**
     * Método que simula a definição de tempo de espera
     * callback
     * timer
     * @param {?} callback
     * @param {?} timer
     * @return {?}
     */
    timeout(callback, timer) {
        return setTimeout(callback, timer);
    }
    /**
     * Método que simula o cancelamento do tempo de espera
     * id
     * @param {?} id
     * @return {?}
     */
    cancelTimeout(id) {
        // do nothing
    }
    /**
     * Método que simula o retorno do elemento ativo
     * @return {?}
     */
    getActiveElement() {
        return document.activeElement;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe fictícia que serve para realizar os testes automatizados
 */
class EmptyMock {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe DeepLinker e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: DeepLinker, useClass: DeepLinkerMock},
 *   ...
 * ]
 * ```
 */
class DeepLinkerMock {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe NavParams e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: NavParams, useClass: NavParamsMock},
 *   ...
 * ]
 * ```
 */
class NavParamsMock {
    /**
     * Método que simula a definição de parâmetros
     * value
     * @param {?} value
     * @return {?}
     */
    static setParams(value) {
        NavParamsMock.returnParam = value;
    }
    /**
     * Método que simula o retorno do valor de uma chave
     * key
     * @param {?} key
     * @return {?}
     */
    get(key) {
        if (NavParamsMock.returnParam) {
            return NavParamsMock.returnParam;
        }
        return 'default';
    }
}
/**
 * Parâmetro de retorno
 */
NavParamsMock.returnParam = null;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe Nav e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Nav, useClass: NavMock},
 *   ...
 * ]
 * ```
 */
class NavMock {
    /**
     * Método que simula o retorno de uma página
     * @return {?}
     */
    pop() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => {
            resolve();
        }));
    }
    /**
     * Método que simula a navegação de uma página
     * @return {?}
     */
    push() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => {
            resolve();
        }));
    }
    /**
     * Método que simula o retorno da página ativa
     * @return {?}
     */
    getActive() {
        return {
            instance: {
                model: 'something',
            },
        };
    }
    /**
     * Método que simula a definição da página base
     * @return {?}
     */
    setRoot() {
        return true;
    }
    /**
     * Método que simula o registro de um Nav
     * nav
     * @param {?} nav
     * @return {?}
     */
    registerChildNav(nav) {
        return;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe SplashScreen e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: SplashScreen, useClass: SplashScreenMock},
 *   ...
 * ]
 * ```
 */
class SplashScreenMock extends SplashScreen {
    /**
     * Método que simula o evento para esconder o 'splash'
     * @return {?}
     */
    hide() {
        return;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe StatusBar e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: StatusBar, useClass: StatusBarMock},
 *   ...
 * ]
 * ```
 */
class StatusBarMock extends StatusBar {
    /**
     * Método que simula o retorno do estilo padrão
     * @return {?}
     */
    styleDefault() {
        return;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Módulo que contém serviços simulados necessários para o desenvolvimento
 * de testes unitários automatizados utilizando ionic
 */
class MockModule {
}
MockModule.decorators = [
    { type: NgModule, args: [{
                imports: [],
                exports: [],
                providers: [
                    // { provide: DeepLinker, useClass: DeepLinkerMock},
                    { provide: NavParams, useClass: NavParamsMock },
                    // { provide: Nav, useClass: NavMock },
                    { provide: Platform, useClass: PlatformMock },
                    { provide: SplashScreen, useClass: SplashScreenMock },
                    { provide: StatusBar, useClass: StatusBarMock }
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Create async observable that emits-once and completes
 *  after a JS engine turn
 * @template T
 * @param {?} data
 * @return {?}
 */
function asyncData(data) {
    return defer((/**
     * @return {?}
     */
    () => Promise.resolve(data)));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Aguardar o espaço de tempo de um quadro na quantidade de quadros/seg
 * desejada para que o ionic renderize corretamente os componentes em tela
 * \@example
 * it('Deveria renderizar', async () => {
 *   await component.ngOnInit();
 *   await render(fixture);
 *   expect(fixture.nativeElement.querySelector('#id').value).toBe('Valor');
 * });
 *
 * @template T
 * @param {?} fixture Referência do componente de teste
 * @param {?=} fps Quantidade de quadros por segundo para referência
 * @return {?}
 */
function render(fixture, fps = 30) {
    return __awaiter(this, void 0, void 0, function* () {
        fixture.detectChanges();
        yield fixture.whenRenderingDone();
        yield fixture.whenStable();
        yield UtilsFn.sleep(1000 / fps);
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PlatformMock, EmptyMock, DeepLinkerMock, NavParamsMock, NavMock, SplashScreenMock, StatusBarMock, MockModule, asyncData, render };

//# sourceMappingURL=totvs-log-mobile-foundation-src-test-utils.js.map