import { __awaiter, __generator, __extends } from 'tslib';
import { UtilsFn } from 'totvs-log-base-foundation';
import { Platform } from '@ionic/angular';
import { SQLite } from '@ionic-native/sqlite/ngx';
import { Injectable, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Gerenciador de conexão de banco de dados sqlite
 * @abstract
 */
var  /**
 * Gerenciador de conexão de banco de dados sqlite
 * @abstract
 */
SqLiteUtilBaseProvider = /** @class */ (function () {
    function SqLiteUtilBaseProvider(sqlLite, platform) {
        this.sqlLite = sqlLite;
        this.platform = platform;
    }
    /**
     * Método para auxiliar a criar uma conexão com o banco sqlite
     * name Nome do banco
     * location Localização do banco
     * DbConnectionBaseProvider
     */
    /**
     * Método para auxiliar a criar uma conexão com o banco sqlite
     * name Nome do banco
     * location Localização do banco
     * DbConnectionBaseProvider
     * @protected
     * @param {?} name
     * @param {?} location
     * @return {?}
     */
    SqLiteUtilBaseProvider.prototype.createConn = /**
     * Método para auxiliar a criar uma conexão com o banco sqlite
     * name Nome do banco
     * location Localização do banco
     * DbConnectionBaseProvider
     * @protected
     * @param {?} name
     * @param {?} location
     * @return {?}
     */
    function (name, location) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.platform.ready()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.sqlLite.create({ name: name, location: location })];
                }
            });
        });
    };
    return SqLiteUtilBaseProvider;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Gerenciador de conexão de banco de dados sqlite
 */
var SqLiteUtilProvider = /** @class */ (function (_super) {
    __extends(SqLiteUtilProvider, _super);
    function SqLiteUtilProvider(sqlLite, platform) {
        var _this = _super.call(this, sqlLite, platform) || this;
        _this.connections = new Array();
        _this.creating = new Array();
        return _this;
    }
    /**
     * Recupera uma conexão de banco de dados
     *
     * name o banco de dados desejado
     * {string} [location='default'] Configuração adicional de localização no dispositivo
     * @returns Um objeto de conexão com o banco
     */
    /**
     * Recupera uma conexão de banco de dados
     *
     * name o banco de dados desejado
     * {string} [location='default'] Configuração adicional de localização no dispositivo
     * @param {?} name
     * @param {?=} location
     * @return {?} Um objeto de conexão com o banco
     */
    SqLiteUtilProvider.prototype.getSqLiteConn = /**
     * Recupera uma conexão de banco de dados
     *
     * name o banco de dados desejado
     * {string} [location='default'] Configuração adicional de localização no dispositivo
     * @param {?} name
     * @param {?=} location
     * @return {?} Um objeto de conexão com o banco
     */
    function (name, location) {
        if (location === void 0) { location = 'default'; }
        return __awaiter(this, void 0, void 0, function () {
            var element, sqlConn, idx;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, UtilsFn.lock((/**
                         * @return {?}
                         */
                        function () { return _this.creating.find((/**
                         * @param {?} x
                         * @return {?}
                         */
                        function (x) { return x.name === name && x.location === location; })); }))];
                    case 1:
                        _a.sent();
                        element = this.connections.find((/**
                         * @param {?} x
                         * @return {?}
                         */
                        function (x) { return x.name === name && x.location === location; }));
                        if (!!element) return [3 /*break*/, 3];
                        this.creating.push({ name: name, location: location, conn: undefined });
                        return [4 /*yield*/, this.createConn(name, location)];
                    case 2:
                        sqlConn = _a.sent();
                        this.connections.push({ name: name, location: location, conn: sqlConn });
                        idx = this.creating.findIndex((/**
                         * @param {?} x
                         * @return {?}
                         */
                        function (x) { return x.name === name && x.location === location; }));
                        if (idx !== -1) {
                            this.creating.splice(idx, 1);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        sqlConn = element.conn;
                        _a.label = 4;
                    case 4: return [2 /*return*/, sqlConn];
                }
            });
        });
    };
    SqLiteUtilProvider.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    SqLiteUtilProvider.ctorParameters = function () { return [
        { type: SQLite },
        { type: Platform }
    ]; };
    return SqLiteUtilProvider;
}(SqLiteUtilBaseProvider));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Módulo que controla as conexões com banco sqlite
 * e provê conexão com o serviço SqLite
 * Usar SqLiteUtilModule.forRoot() ao importar
 * @export
 * SqLiteUtilModule
 */
var SqLiteUtilModule = /** @class */ (function () {
    function SqLiteUtilModule() {
    }
    /**
     * @return {?}
     */
    SqLiteUtilModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: SqLiteUtilModule,
            providers: [
                SQLite,
                {
                    provide: SqLiteUtilBaseProvider,
                    useClass: SqLiteUtilProvider
                }
            ]
        };
    };
    SqLiteUtilModule.decorators = [
        { type: NgModule, args: [{
                    providers: []
                },] }
    ];
    return SqLiteUtilModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { SqLiteUtilBaseProvider, SqLiteUtilProvider, SqLiteUtilModule };

//# sourceMappingURL=totvs-log-mobile-foundation-src-sqlite-util.js.map