import { NgModule } from '@angular/core';
import { Platform, NavParams } from '@ionic/angular';
import { StatusBar } from '@ionic-native/status-bar/ngx';
import { SplashScreen } from '@ionic-native/splash-screen/ngx';
import { defer } from 'rxjs';
import { __awaiter, __generator, __extends } from 'tslib';
import { UtilsFn } from 'totvs-log-base-foundation';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe Platform e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Platform, useClass: PlatformMock},
 *   ...
 * ]
 * ```
 */
var  /**
 * Esta classe simula a classe Platform e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Platform, useClass: PlatformMock},
 *   ...
 * ]
 * ```
 */
PlatformMock = /** @class */ (function () {
    function PlatformMock() {
    }
    /**
     * Método que simula a ação de preparado da plataforma
     */
    /**
     * Método que simula a ação de preparado da plataforma
     * @return {?}
     */
    PlatformMock.prototype.ready = /**
     * Método que simula a ação de preparado da plataforma
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            resolve('READY');
        }));
    };
    /**
     * Método que simula o retorno dos parâmetros de query de URL
     */
    /**
     * Método que simula o retorno dos parâmetros de query de URL
     * @return {?}
     */
    PlatformMock.prototype.getQueryParam = /**
     * Método que simula o retorno dos parâmetros de query de URL
     * @return {?}
     */
    function () {
        return true;
    };
    /**
     * Método que simula o registro da ação para o botão 'Voltar'
     * fn
     * priority
     */
    /**
     * Método que simula o registro da ação para o botão 'Voltar'
     * fn
     * priority
     * @param {?} fn
     * @param {?=} priority
     * @return {?}
     */
    PlatformMock.prototype.registerBackButtonAction = /**
     * Método que simula o registro da ação para o botão 'Voltar'
     * fn
     * priority
     * @param {?} fn
     * @param {?=} priority
     * @return {?}
     */
    function (fn, priority) {
        return ((/**
         * @return {?}
         */
        function () { return true; }));
    };
    /**
     * Método que simula a verificação de foco
     * ele
     */
    /**
     * Método que simula a verificação de foco
     * ele
     * @param {?} ele
     * @return {?}
     */
    PlatformMock.prototype.hasFocus = /**
     * Método que simula a verificação de foco
     * ele
     * @param {?} ele
     * @return {?}
     */
    function (ele) {
        return true;
    };
    /**
     * Método que simula o retorno do 'document'
     */
    /**
     * Método que simula o retorno do 'document'
     * @return {?}
     */
    PlatformMock.prototype.doc = /**
     * Método que simula o retorno do 'document'
     * @return {?}
     */
    function () {
        return document;
    };
    /**
     * Método que simula o retorno do 'is'
     */
    /**
     * Método que simula o retorno do 'is'
     * @return {?}
     */
    PlatformMock.prototype.is = /**
     * Método que simula o retorno do 'is'
     * @return {?}
     */
    function () {
        return true;
    };
    /**
     * Método que simula o retorno do estilo de um elemento
     * container
     */
    /**
     * Método que simula o retorno do estilo de um elemento
     * container
     * @param {?} container
     * @return {?}
     */
    PlatformMock.prototype.getElementComputedStyle = /**
     * Método que simula o retorno do estilo de um elemento
     * container
     * @param {?} container
     * @return {?}
     */
    function (container) {
        return {
            paddingLeft: '10',
            paddingTop: '10',
            paddingRight: '10',
            paddingBottom: '10',
        };
    };
    /**
     * Método que simula o evento de redimensionamento de tela
     * callback
     */
    /**
     * Método que simula o evento de redimensionamento de tela
     * callback
     * @param {?} callback
     * @return {?}
     */
    PlatformMock.prototype.onResize = /**
     * Método que simula o evento de redimensionamento de tela
     * callback
     * @param {?} callback
     * @return {?}
     */
    function (callback) {
        return callback;
    };
    /**
     * Método que simula o registro de evento de escuta
     * ele
     * eventName
     * callback
     */
    /**
     * Método que simula o registro de evento de escuta
     * ele
     * eventName
     * callback
     * @param {?} ele
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    PlatformMock.prototype.registerListener = /**
     * Método que simula o registro de evento de escuta
     * ele
     * eventName
     * callback
     * @param {?} ele
     * @param {?} eventName
     * @param {?} callback
     * @return {?}
     */
    function (ele, eventName, callback) {
        return ((/**
         * @return {?}
         */
        function () { return true; }));
    };
    /**
     * Método que simula o retorno do método 'win'
     */
    /**
     * Método que simula o retorno do método 'win'
     * @return {?}
     */
    PlatformMock.prototype.win = /**
     * Método que simula o retorno do método 'win'
     * @return {?}
     */
    function () {
        return window;
    };
    /**
     * Método que simula o retorno do método 'raf'
     * callback
     */
    /**
     * Método que simula o retorno do método 'raf'
     * callback
     * @param {?} callback
     * @return {?}
     */
    PlatformMock.prototype.raf = /**
     * Método que simula o retorno do método 'raf'
     * callback
     * @param {?} callback
     * @return {?}
     */
    function (callback) {
        return 1;
    };
    /**
     * Método que simula a definição de tempo de espera
     * callback
     * timer
     */
    /**
     * Método que simula a definição de tempo de espera
     * callback
     * timer
     * @param {?} callback
     * @param {?} timer
     * @return {?}
     */
    PlatformMock.prototype.timeout = /**
     * Método que simula a definição de tempo de espera
     * callback
     * timer
     * @param {?} callback
     * @param {?} timer
     * @return {?}
     */
    function (callback, timer) {
        return setTimeout(callback, timer);
    };
    /**
     * Método que simula o cancelamento do tempo de espera
     * id
     */
    /**
     * Método que simula o cancelamento do tempo de espera
     * id
     * @param {?} id
     * @return {?}
     */
    PlatformMock.prototype.cancelTimeout = /**
     * Método que simula o cancelamento do tempo de espera
     * id
     * @param {?} id
     * @return {?}
     */
    function (id) {
        // do nothing
    };
    /**
     * Método que simula o retorno do elemento ativo
     */
    /**
     * Método que simula o retorno do elemento ativo
     * @return {?}
     */
    PlatformMock.prototype.getActiveElement = /**
     * Método que simula o retorno do elemento ativo
     * @return {?}
     */
    function () {
        return document.activeElement;
    };
    return PlatformMock;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe fictícia que serve para realizar os testes automatizados
 */
var  /**
 * Classe fictícia que serve para realizar os testes automatizados
 */
EmptyMock = /** @class */ (function () {
    function EmptyMock() {
    }
    return EmptyMock;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe DeepLinker e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: DeepLinker, useClass: DeepLinkerMock},
 *   ...
 * ]
 * ```
 */
var  /**
 * Esta classe simula a classe DeepLinker e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: DeepLinker, useClass: DeepLinkerMock},
 *   ...
 * ]
 * ```
 */
DeepLinkerMock = /** @class */ (function () {
    function DeepLinkerMock() {
    }
    return DeepLinkerMock;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe NavParams e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: NavParams, useClass: NavParamsMock},
 *   ...
 * ]
 * ```
 */
var NavParamsMock = /** @class */ (function () {
    function NavParamsMock() {
    }
    /**
     * Método que simula a definição de parâmetros
     * value
     */
    /**
     * Método que simula a definição de parâmetros
     * value
     * @param {?} value
     * @return {?}
     */
    NavParamsMock.setParams = /**
     * Método que simula a definição de parâmetros
     * value
     * @param {?} value
     * @return {?}
     */
    function (value) {
        NavParamsMock.returnParam = value;
    };
    /**
     * Método que simula o retorno do valor de uma chave
     * key
     */
    /**
     * Método que simula o retorno do valor de uma chave
     * key
     * @param {?} key
     * @return {?}
     */
    NavParamsMock.prototype.get = /**
     * Método que simula o retorno do valor de uma chave
     * key
     * @param {?} key
     * @return {?}
     */
    function (key) {
        if (NavParamsMock.returnParam) {
            return NavParamsMock.returnParam;
        }
        return 'default';
    };
    /**
     * Parâmetro de retorno
     */
    NavParamsMock.returnParam = null;
    return NavParamsMock;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe Nav e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Nav, useClass: NavMock},
 *   ...
 * ]
 * ```
 */
var  /**
 * Esta classe simula a classe Nav e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Nav, useClass: NavMock},
 *   ...
 * ]
 * ```
 */
NavMock = /** @class */ (function () {
    function NavMock() {
    }
    /**
     * Método que simula o retorno de uma página
     */
    /**
     * Método que simula o retorno de uma página
     * @return {?}
     */
    NavMock.prototype.pop = /**
     * Método que simula o retorno de uma página
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            resolve();
        }));
    };
    /**
     * Método que simula a navegação de uma página
     */
    /**
     * Método que simula a navegação de uma página
     * @return {?}
     */
    NavMock.prototype.push = /**
     * Método que simula a navegação de uma página
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            resolve();
        }));
    };
    /**
     * Método que simula o retorno da página ativa
     */
    /**
     * Método que simula o retorno da página ativa
     * @return {?}
     */
    NavMock.prototype.getActive = /**
     * Método que simula o retorno da página ativa
     * @return {?}
     */
    function () {
        return {
            instance: {
                model: 'something',
            },
        };
    };
    /**
     * Método que simula a definição da página base
     */
    /**
     * Método que simula a definição da página base
     * @return {?}
     */
    NavMock.prototype.setRoot = /**
     * Método que simula a definição da página base
     * @return {?}
     */
    function () {
        return true;
    };
    /**
     * Método que simula o registro de um Nav
     * nav
     */
    /**
     * Método que simula o registro de um Nav
     * nav
     * @param {?} nav
     * @return {?}
     */
    NavMock.prototype.registerChildNav = /**
     * Método que simula o registro de um Nav
     * nav
     * @param {?} nav
     * @return {?}
     */
    function (nav) {
        return;
    };
    return NavMock;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe SplashScreen e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: SplashScreen, useClass: SplashScreenMock},
 *   ...
 * ]
 * ```
 */
var  /**
 * Esta classe simula a classe SplashScreen e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: SplashScreen, useClass: SplashScreenMock},
 *   ...
 * ]
 * ```
 */
SplashScreenMock = /** @class */ (function (_super) {
    __extends(SplashScreenMock, _super);
    function SplashScreenMock() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Método que simula o evento para esconder o 'splash'
     */
    /**
     * Método que simula o evento para esconder o 'splash'
     * @return {?}
     */
    SplashScreenMock.prototype.hide = /**
     * Método que simula o evento para esconder o 'splash'
     * @return {?}
     */
    function () {
        return;
    };
    return SplashScreenMock;
}(SplashScreen));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Esta classe simula a classe StatusBar e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: StatusBar, useClass: StatusBarMock},
 *   ...
 * ]
 * ```
 */
var  /**
 * Esta classe simula a classe StatusBar e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: StatusBar, useClass: StatusBarMock},
 *   ...
 * ]
 * ```
 */
StatusBarMock = /** @class */ (function (_super) {
    __extends(StatusBarMock, _super);
    function StatusBarMock() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Método que simula o retorno do estilo padrão
     */
    /**
     * Método que simula o retorno do estilo padrão
     * @return {?}
     */
    StatusBarMock.prototype.styleDefault = /**
     * Método que simula o retorno do estilo padrão
     * @return {?}
     */
    function () {
        return;
    };
    return StatusBarMock;
}(StatusBar));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Módulo que contém serviços simulados necessários para o desenvolvimento
 * de testes unitários automatizados utilizando ionic
 */
var MockModule = /** @class */ (function () {
    function MockModule() {
    }
    MockModule.decorators = [
        { type: NgModule, args: [{
                    imports: [],
                    exports: [],
                    providers: [
                        // { provide: DeepLinker, useClass: DeepLinkerMock},
                        { provide: NavParams, useClass: NavParamsMock },
                        // { provide: Nav, useClass: NavMock },
                        { provide: Platform, useClass: PlatformMock },
                        { provide: SplashScreen, useClass: SplashScreenMock },
                        { provide: StatusBar, useClass: StatusBarMock }
                    ]
                },] }
    ];
    return MockModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Create async observable that emits-once and completes
 *  after a JS engine turn
 * @template T
 * @param {?} data
 * @return {?}
 */
function asyncData(data) {
    return defer((/**
     * @return {?}
     */
    function () { return Promise.resolve(data); }));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Aguardar o espaço de tempo de um quadro na quantidade de quadros/seg
 * desejada para que o ionic renderize corretamente os componentes em tela
 * \@example
 * it('Deveria renderizar', async () => {
 *   await component.ngOnInit();
 *   await render(fixture);
 *   expect(fixture.nativeElement.querySelector('#id').value).toBe('Valor');
 * });
 *
 * @template T
 * @param {?} fixture Referência do componente de teste
 * @param {?=} fps Quantidade de quadros por segundo para referência
 * @return {?}
 */
function render(fixture, fps) {
    if (fps === void 0) { fps = 30; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fixture.detectChanges();
                    return [4 /*yield*/, fixture.whenRenderingDone()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, fixture.whenStable()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, UtilsFn.sleep(1000 / fps)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PlatformMock, EmptyMock, DeepLinkerMock, NavParamsMock, NavMock, SplashScreenMock, StatusBarMock, MockModule, asyncData, render };

//# sourceMappingURL=totvs-log-mobile-foundation-src-test-utils.js.map