import { Events } from '@ionic/angular';
import { WebStorageStateStore } from 'oidc-client';
import { OidcCordovaIFrameNavigator } from 'totvs-log-mobile-foundation/src/oidc-cordova';
import { OidcCordovaPopupNavigator } from 'totvs-log-mobile-foundation/src/oidc-cordova';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
import { IAuthSettings, IAuthHandlerType } from 'totvs-log-base-foundation';
import { ModuleWithProviders } from '@angular/core';
export declare function authFactory(iab: InAppBrowser, events: Events, authSettings: IAuthSettings): IAuthSettings & {
    popupNavigator: OidcCordovaPopupNavigator;
    iframeNavigator: OidcCordovaIFrameNavigator;
    checkSessionInterval: number;
    userStore: WebStorageStateStore;
};
/**
 * Módulo que exporta e ativa as dependências para utilizar autenticação com fluxo oauth2
 * Para garantir que os serviços tenham uma única instância, usar AuthModule.forRoot() ao importar
 * @export
 * FndModule
 */
export declare class AuthModule {
    /**
     * @dynamic
     */
    static forRoot(authSettings: IAuthSettings, handlerTypeSettings: IAuthHandlerType): ModuleWithProviders;
}
