import { Events } from '@ionic/angular';
import { AuthBaseService, IAuthSettings, IAuthHandlerType } from 'totvs-log-base-foundation';
export declare class AuthService extends AuthBaseService {
    private events;
    /**
     * Propriedade que recebe o tipo de autentição injetado via token
     */
    authType: IAuthHandlerType;
    /**
     * Método construtor da classe
     * authSettings Token de injeção com as configurações de autenticação
     * authType Token de injeção com o tipo de autenticação
     */
    constructor(authSettings: IAuthSettings, authType: IAuthHandlerType, events: Events);
    /**
     * Método responsável executar o processo de login/autenticação
     */
    loginFlow(): Promise<void>;
    /**
     * Método responsável executar o processo de logout
     */
    logoutFlow(): Promise<void>;
}
