import { ILiteralsLoader, II18nBaseOptions } from 'totvs-log-base-foundation';
import { Observable } from 'rxjs';
import { ILiterals } from 'totvs-log-base-foundation';
import { TranslateService } from '@ngx-translate/core';
/**
 * Serviço utilizado para carregar as literais
 */
export declare class IntlLiteralsLoaderService implements ILiteralsLoader {
    private translate;
    /**
     * Responsável por receber as configurações do serviço de tradução para carregar as literais
     */
    private mobileOptions;
    /**
     * Método construtor da classe
     * translate
     */
    constructor(translate: TranslateService);
    /**
     * Método responsável por setar as opções e retornar a literal atualizada
     * options
     */
    updateOptions(options: II18nBaseOptions): Observable<ILiterals>;
    /**
     * Método responsável por setar o carregamento e retornar a literal atualizada
     */
    load(): Observable<ILiterals>;
}
