import { IIntlConfig } from './intl-config.interface';
import { I18nBaseService, II18nBaseOptions } from 'totvs-log-base-foundation';
import { InjectionToken } from '@angular/core';
import { IntlLiteralsLoaderService } from './intl-literal-loader.service';
/**
 * Token de configuração da url de internacionalização
 */
export declare const INTL_CONFIG: InjectionToken<IIntlConfig>;
/**
 * Serviço de internacionalização da aplicação
 */
export declare class IntlService extends I18nBaseService {
    /**
     * Atributo de opções de internacionalização
     */
    options: II18nBaseOptions;
    /**
     * Método construtor que inicializa a classe
     * translate Serviço de internacionalização
     */
    constructor(config: IIntlConfig, intlLiteralsLoader: IntlLiteralsLoaderService);
}
