import { ToastController, AlertController } from '@ionic/angular';
import { AbstractShowMessage, ShowMessageOptions } from 'totvs-log-base-foundation';
/**
 * Serviço responsável pela apresentação de mensagens
 */
export declare class ShowMessageService extends AbstractShowMessage {
    private toastCtrl;
    private alertCtrl;
    /**
     * Método construtor que inicializa a classe
     * toastCtrl Serviço de TOAST
     * alertCtrl Serviço de Alerta
     * i18n Serviço de internacionalização
     */
    constructor(toastCtrl: ToastController, alertCtrl: AlertController);
    /**
     * Método responsável por apresentar uma mensagem
     */
    displayMessage(showMessageOptions: ShowMessageOptions): Promise<void>;
    /**
     * Método responsável por apresentar uma mensagem de notificação
     */
    private showNotification;
    /**
     * Método responsável por apresentar uma mensagem de diálogo
     */
    private showDialog;
    /**
     * Método responsável pela abertura de um link
     */
    private openLink;
}
