import { Storage } from '@ionic/storage';
import { Platform, Events } from '@ionic/angular';
import { ITenant } from './tenant.interface';
export declare class MultiTenantService {
    private storage;
    private events;
    static SHORT_NAME_TENANT_FIELD: string;
    static IS_DEMONSTRATION: string;
    /**
     * @ignore
     * Propriedade de armazenamento de dados no dispositivo
     */
    private tenantsStorage;
    readonly tenants: Array<ITenant>;
    /**
     * @ignore
     * Propriedade de armazenamento de dados no dispositivo (tenant corrente)
     */
    private currentTenantStorage;
    /**
     * @ignore
     * Indica se a plataforma é cordova
     */
    private isCordova;
    private ready;
    private readyFn;
    readonly isReady: Promise<void>;
    /**
     * Método construtor responsável por inicializar o serviço
     * @param platform Serviço relacionado a plataforma
     * @param storage Serviço relacionado ao storage
     */
    constructor(platform: Platform, storage: Storage, events: Events);
    getCurrentTenant(): Promise<ITenant>;
    setCurrentTenant(currentTenant: ITenant): Promise<void>;
    addTenant(tenant: ITenant): Promise<ITenant>;
    deleteTenant(tenant: ITenant): Promise<void>;
    private sortTenantsByShortName;
}
