import { GeolocationOptions, Geoposition } from '@ionic-native/geolocation/ngx';
import { IGeoPosition } from './geo-position.interface';
/**
 * Interface que define as propriedades e comportamentos do
 * utilitário de geolocalização
 */
export interface IGeolocationUtil {
    /**
     * Método responsável por obter a posição corrente do usuário
     * {GeolocationOptions} options Opções para recuperação da geolocalização
     * Posição
     */
    getCurrentPosition(options: GeolocationOptions): Promise<Geoposition>;
    /**
     * Método responsável por calcular a distância entre dois pontos através de suas latitudes e longitudes
     * point1 Coordenadas do primeiro ponto
     * point2 Coordenadas do segundo ponto
     */
    calculatePointsKMDistance(point1: IGeoPosition, point2: IGeoPosition): number;
}
