import { IHttpUtilResult } from './http-util-result.interface';
/**
 * Interface que define as propriedades e comportamentos do
 * utilitário de requisição Http
 */
export interface IHttpUtil {
    /**
     * Método responsável por realizar o upload de um arquivo
     * @template T Objeto de resposta do servidor quando sucesso
     * url URL do Endpoint de Upload
     * filePath URI do arquivo no dispositivo
     * name Nome do arquivo
     * body Informações no corpo da mensagem
     * headers Informações de cabeçalho da mensagem
     * {IHttpUtilResult} Resultado da requisição
     */
    uploadFile<T>(url: string, filePath: string, name?: string, body?: any, headers?: any): Promise<IHttpUtilResult<T>>;
    /**
     * Método que permite a alteração do modo de verificação do certificado SSL
     * mode Modo de verificação do certificado SSL
     */
    setSSLCertMode(mode: 'default' | 'nocheck' | 'pinned'): any;
}
