import { IOidcCordovaPopupWindow } from './oidc-cordova-popup-window.interface';
import { Subject } from 'rxjs';
import { InAppBrowser } from '@ionic-native/in-app-browser/ngx';
/**
 * Classe responsável pelo Popup utilizado no processo
 * de autenticação com Oidc no Ionic
 */
export declare class OidcCordovaPopupWindow implements IOidcCordovaPopupWindow {
    private iab;
    private popupParams;
    /** Propriedades padrão do Popup */
    private static DefaultPopupFeatures;
    /** Destino padrão do Popup */
    private static DefaultPopupTarget;
    /** Promise retornado pelo método Navigate */
    private internalPromise;
    /** Reject do promise retornado pelo método Navigate */
    private internalReject;
    /** Método acessor do promise retornado pelo método Navigate */
    readonly promise: Promise<any>;
    /** URL de redirecionamento */
    private redirectUri;
    /** Janela de popup */
    private popup;
    /** Subscrição do evento 'exit' do popup */
    private popupExitSub;
    /** Subscrição do evento 'loadstart' do popup */
    private popupLoadStartSub;
    /**
     * Método construtor que inicializa a classe
     * iab Serviço do plugin nativo ionic InAppBrowser
     * popupParams Parâmetros para o popup
     */
    constructor(iab: InAppBrowser, popupParams: any);
    navigated: Subject<Promise<any>>;
    /**
     * Método responsável por realizar a navegação
     * navParams Parâmetros de navegação
     */
    navigate(navParams: any): Promise<any>;
    /**
     * Método responsável por fechar
     */
    close(): void;
    /**
     * Método responsável por fechar o popup
     */
    private closePopup;
}
