import { GlobalService } from 'totvs-log-mobile-foundation';
import { ISpeechRecognitionUtil } from './speech-recognition-util.interface';
import { Platform } from '@ionic/angular';
import { SpeechRecognition } from '@ionic-native/speech-recognition/ngx';
/**
 * Utilitário para auxiliar o desenvolvimento utilizando o plugin de reconhecimento de voz
 * com métodos que facilitam a solicitação de permissão e reconhecimento
 */
export declare class SpeechRecognitionUtilProvider implements ISpeechRecognitionUtil {
    private speechRecognition;
    private global;
    /**
     * @ignore
     * Indica se a plataforma é cordova
     */
    private isCordova;
    /**
     * @ignore
     * Opções do reconhecimento
     */
    private options;
    /**
     * @ignore
     * Método responsável por construir o serviço
     * platform Serviço relacionado a plataforma
     * speechRecognition Serviço do plugin nativo de reconhecimento de voz
     * global Serviço global da aplicação
     */
    constructor(platform: Platform, speechRecognition: SpeechRecognition, global: GlobalService);
    /**
     * Método responsável por habilitar o reconheicimento de voz
     * Lista com os textos reconhecidos (geralmente o primeiro item é o mais provável)
     */
    listening(): Promise<string[]>;
    /**
     * @ignore
     * Método responsável por verificar se há permissão e se não houver, solicitar
     * Indicação se há ou não permissão
     */
    private verifyPermission;
    /**
     * @ignore
     * Método responsável por solicitar permissão de voz
     * Indicação se a permissão foi ou não concedida
     */
    private requestPermission;
    /**
     * @ignore
     * Método para apresentar mensagens
     * literalMessage Literal da mensagem
     */
    private showToast;
}
