import { Platform } from '@ionic/angular';
import { SQLite, SQLiteObject } from '@ionic-native/sqlite/ngx';
import { SqLiteUtilBaseProvider } from './sqlite-util-base';
import { ISqLiteConn } from './sqlite-conn.interface';
/**
 * Gerenciador de conexão de banco de dados sqlite
 */
export declare class SqLiteUtilProvider extends SqLiteUtilBaseProvider {
    /**
     * As conexões já criadas
     */
    protected connections: ISqLiteConn[];
    /**
     * @ignore
     * Se há uma conexão sendo criada no momento
     */
    private creating;
    constructor(sqlLite: SQLite, platform: Platform);
    /**
     * Recupera uma conexão de banco de dados
     *
     * name o banco de dados desejado
     * {string} [location='default'] Configuração adicional de localização no dispositivo
     * @returns Um objeto de conexão com o banco
     */
    getSqLiteConn(name: string, location?: string): Promise<SQLiteObject>;
}
