import { InjectionToken } from '@angular/core';
import { SyncHandler } from './sync-handler';
/**
 * Interface de sincronização de uma entidade
 */
export interface ISyncEntity {
    /**
     * Ordem de execução que pode indicar que uma entidade deve ser sincronizada após outra entidade
     */
    order?: number;
    /**
     * O nome da entidade
     */
    name: string;
    /**
     * O token do provider do serviço
     */
    providerToken: InjectionToken<SyncHandler>;
}
