import { ISyncEntityState } from './sync-entity-state.interface';
/**
 * Interface de resultado de sincronização.
 * Na implementação concreta, utilizar a interface fortemente tipada,
 * ISyncResult<T>
 */
export interface ISyncResultBase {
    /**
     * O estado da sincronização
     */
    state: ISyncEntityState;
    /**
     * Os dados relacionados com a sincronização
     */
    data: any[];
}
/**
 * Interface de resultado de sincronização.
 *
 */
export interface ISyncResult<T> extends ISyncResultBase {
    /**
     * Os dados fortemente tipados relacionados com a sincronização
     */
    data: T[];
}
