/**
 * Tipos de rede para a sincronização
 */
export declare type NetworkTypes = 'any' | 'unknown' | 'ethernet' | 'wifi' | '2g' | '3g' | '4g' | 'cellular';
/**
 * Interface de configuração de sincronização automática
 * @example
 * {
 * checkType : 'minutes', checkQuantity: 2 // Vai verificar a cada 2 minutos
 * }
 */
export interface ISyncWatch {
    /**
     * Período a ser considerado na sincronização
     */
    checkType: 'days' | 'hours' | 'minutes' | 'seconds';
    /**
     * Quantidade a ser aplicada entre verificações, padrão 1
     */
    checkQuantity?: number;
    /**
     * Indica em quais redes a sincronização estará ativa
     */
    enabledOnNetwork: NetworkTypes | NetworkTypes[];
    /**
     * Indica se a sincronização deve iniciar automáticamente
     */
    auto?: boolean;
}
