/**
 * Esta classe simula a classe Nav e é utilizada
 * para os testes unitários automatizados
 * ```typescript
 * // Utilizar como provider
 * providers: [
 *   { provide: Nav, useClass: NavMock},
 *   ...
 * ]
 * ```
 */
export declare class NavMock {
    /**
     * Método que simula o retorno de uma página
     */
    pop(): any;
    /**
     * Método que simula a navegação de uma página
     */
    push(): any;
    /**
     * Método que simula o retorno da página ativa
     */
    getActive(): any;
    /**
     * Método que simula a definição da página base
     */
    setRoot(): any;
    /**
     * Método que simula o registro de um Nav
     * nav
     */
    registerChildNav(nav: any): void;
}
