import { ComponentFixture } from '@angular/core/testing';
/**
 * Aguardar o espaço de tempo de um quadro na quantidade de quadros/seg
 * desejada para que o ionic renderize corretamente os componentes em tela
 * @param fixture Referência do componente de teste
 * @param fps Quantidade de quadros por segundo para referência
 * @example
 * it('Deveria renderizar', async () => {
 *   await component.ngOnInit();
 *   await render(fixture);
 *   expect(fixture.nativeElement.querySelector('#id').value).toBe('Valor');
 * });
 *
 */
export declare function render<T>(fixture: ComponentFixture<T>, fps?: number): Promise<void>;
